.proxy:
  stage: proxy
  tags:
    - testbetrieb
  when: manual

caddy_konfiguration_pruefen:
  stage: proxy
  image:
    name: caddy:latest
    entrypoint: [""]
  script:
    - caddy fmt --diff proxy/Caddyfile

proxy_aufsetzen:
  extends: .proxy
  script:
    - if [ -z "$DATEN_VERWERFEN" ] && openstack server show proxy; then ssh ubuntu@proxy -- sudo bash -xe < proxy/backup.sh; fi
    - openstack server delete
      proxy
      --wait || true
    - openstack server create
      --flavor eo1.xsmall
      --image "Ubuntu 24.04 Minimal"
      --network testbetrieb
      --security-group default
      --security-group web
      --key-name gitlab-runner
      proxy
      --wait
    - openstack server add volume
      proxy proxy
    - openstack server add floating ip
      proxy 74.63.10.210
    - ssh-keygen -R proxy || true
    - until ssh ubuntu@proxy systemctl is-active --quiet cloud-init.target; do sleep 1s; done
    - ssh ubuntu@proxy -- sudo bash -xe < proxy/install.sh
    - if [ -z "$DATEN_VERWERFEN" -o "$DATEN_VERWERFEN" = "zurücksetzen" ]; then ssh ubuntu@proxy -- sudo bash -xe < proxy/restore.sh; fi

proxy_konfigurieren:
  extends: .proxy
  script:
    - ssh ubuntu@proxy -- "sudo tee /etc/caddy/Caddyfile > /dev/null" < proxy/Caddyfile
    - ssh ubuntu@proxy -- sudo systemctl reload caddy

.proxy_sichern:
  extends: .proxy
  script:
    - ssh ubuntu@proxy -- sudo bash -xe < proxy/backup.sh

proxy_sichern_manuell:
  extends: .proxy_sichern

proxy_sichern_automatisch:
  extends: .proxy_sichern
  rules:
    - if: $CI_PIPELINE_SOURCE == "schedule"
      when: always
      allow_failure: false

proxy_wiederherstellen:
  extends: .proxy
  script:
    - ssh ubuntu@proxy -- sudo bash -xe < proxy/restore.sh


md-editor_aktualisieren:
  extends: .proxy
  before_script:
    - 'curl --header "PRIVATE-TOKEN: ${MD_EDITOR_TOKEN}" https://gitlab.opencode.de/api/v4/projects/2318/jobs/artifacts/${ZWEIG}/download?job=build --output artifacts.zip'
    - unzip artifacts.zip
  script:
    - ssh ubuntu@proxy -- sudo mkdir -p /var/www/md-editor
    - rsync --rsync-path="sudo rsync" --recursive --delete dist ubuntu@proxy:/var/www/md-editor

